#!/usr/bin/env python3

import shapefile

with shapefile.Reader("extremum") as extremum, \
     shapefile.Reader("outermost_contour") as outermost_cont, \
     shapefile.Reader("max_speed_contour") as max_speed_cont, \
     shapefile.Writer("extremum_filtered") as extremum_filt, \
     shapefile.Writer("outermost_contour_filtered") as outermost_cont_filt, \
     shapefile.Writer("max_speed_contour_filtered") as max_speed_cont_filt:
    extremum_filt.fields = extremum.fields[1:]
    outermost_cont_filt.fields = outermost_cont.fields[1:]
    max_speed_cont_filt.fields = max_speed_cont.fields[1:]
    
    for shape_rec_extr, shape_rec_outer, shape_rec_max \
        in zip(extremum, outermost_cont, max_speed_cont):
        if shape_rec_extr.record.speed == 1e4 \
           and shape_rec_outer.record.radius4 >= 2:
            extremum_filt.record(*shape_rec_extr.record)
            extremum_filt.shape(shape_rec_extr.shape)
            
            outermost_cont_filt.record(*shape_rec_outer.record)
            outermost_cont_filt.shape(shape_rec_outer.shape)
            
            max_speed_cont_filt.record(*shape_rec_max.record)
            max_speed_cont_filt.shape(shape_rec_max.shape)
