module candidate_overlap_m

  implicit none

contains

  function candidate_overlap(extr_map, list_vis, cyclone)

    ! Find the eddies in extr_map that are valid and have a given
    ! cyclonicity.

    use derived_types, only: eddy

    integer, allocatable:: candidate_overlap(:)

    integer, intent(in):: extr_map(:, :)
    ! At a point of extremum SSH: identification number or this
    ! extremum. 0 at other points.

    type(eddy), intent(in):: list_vis(:)
    ! Visible eddies at a given date. We need components ? to be defined.

    logical, intent(in):: cyclone ! cyclonicity of the target extremum

    !---------------------------------------------------------------------

    candidate_overlap = pack(extr_map, extr_map /= 0)
    candidate_overlap = pack(candidate_overlap, &
         list_vis(candidate_overlap)%valid &
         .and. (list_vis(candidate_overlap)%cyclone .eqv. cyclone))
    
  end function candidate_overlap

end module candidate_overlap_m
